#!/usr/bin/env python
# -*- coding: utf-8 -*-
# $Id: xsend.py,v 1.8 2006/10/06 12:30:42 normanr Exp $
# improved for multiple jids, variable config file: 2010/03/03 Rene Milk
import sys,os,time
os.path.join(sys.path,'/usr/lib/python2.6/site-packages/xmpp/')
import xmpp
debug=False
def dbg( *kwargs ):
	global debug
	if debug:
		print kwargs

if len(sys.argv) < 2:
    print "Syntax: %s text JIDS"%sys.argv[0]
    sys.exit(0)

tojids=sys.argv[2:]
text=sys.argv[1]
dbg('jids: %s, text: %s'%(str(tojids),text))
jidparams={}
config_file_path = '%s/.%s'%(os.environ['HOME'],os.path.split(sys.argv[0])[-1].replace('.py',''))
if os.access(config_file_path,os.R_OK):
    for ln in open(config_file_path).readlines():
        if not ln[0] in ('#',';'):
            key,val=ln.strip().split('=',1)
            jidparams[key.lower()]=val
for mandatory in ['jid','password']:
    if mandatory not in jidparams.keys():
        open(config_file_path,'w').write('#Uncomment fields before use and type in correct credentials.\n#JID=romeo@montague.net/resource (/resource is optional)\n#PASSWORD=juliet\n')
        print 'Please point %s config file to valid JID for sending messages.'%config_file_path
        sys.exit(0)

jid=xmpp.protocol.JID(jidparams['jid'])
cl=xmpp.Client(jid.getDomain(),debug=[])

con=cl.connect()
if not con:
    print 'could not connect!'
    sys.exit()
dbg( 'connected with',con )
auth=cl.auth(jid.getNode(),jidparams['password'],resource=jid.getResource())
if not auth:
    print 'could not authenticate!'
    sys.exit()
dbg ('authenticated using',auth)

#cl.SendInitPresence(requestRoster=0)   # you may need to uncomment this for old server
for tojid in tojids:
	cl.send(xmpp.protocol.Message(to=tojid,body=text,typ='chat'))
	time.sleep(1)   # some older servers will not send the message if you disconnect immediately after sending

cl.disconnect()
